Attribute VB_Name = "modWinBatch"
Option Explicit

' *****************************************
' * Winbatch Main Module
' * 1998 Jonn Blanchard
' *
' * This program acts as a kind of Batch Language for Windows
' * Most of the commands have examples in the Test.WBT test file
' * And are explained in the Winbatch.txt file

Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Dim vntVars(12), iStackValue As Integer
Dim sCommandArray() As String
Dim iReturnStack() As Integer
Dim iNumCommands As Integer, iCurCommand As Integer
Dim sLabelsArray() As String
Dim iNumLabels As Integer
Dim bFinish As Boolean
Dim sWinDir As String, sSysDir As String
Private Sub GetSysDir()
Dim sSysStr As String * 256, lreturnLen As Long
sSysStr = Space$(256)
lreturnLen = GetSystemDirectory(sSysStr, 256)
sSysDir = Left$(sSysStr, lreturnLen)
If Right$(sSysDir, 1) <> "\" Then sSysDir = sSysDir & "\"
End Sub

Private Sub GetWinDir()
Dim sWinStr As String * 256, ireturnLen As Integer
sWinStr = Space$(256)
ireturnLen = GetWindowsDirectory(sWinStr, 256)
sWinDir = Left$(sWinStr, ireturnLen)
If Right$(sWinDir, 1) <> "\" Then sWinDir = sWinDir & "\"
End Sub

Sub Pause(timeout)
Dim dt, dx
dt = Time
dx = DateAdd("s", timeout, dt)
Do While DateDiff("s", dt, dx) > 0
    DoEvents
    dt = Time
Loop
End Sub

Function Activate(sCommandName As String, sCommandParams As String, iVarsNum As Integer) As Boolean
' **********************************
' * Activate
' * Processes the various commands
' * Jonn Blanchard

Dim sLft As String, sRgt As String, iIns As Integer, iupload As Integer
Dim X As Long, iTemp As Integer

On Error GoTo noExec
If sCommandParams <> "" Then
    sLft = sCommandParams
    sRgt = ""
    iIns = InStr(sCommandParams, ",") - 1
    If iIns > 0 Then
        sLft = Trim$(Left$(sCommandParams, iIns))
        sRgt = Trim$(Right$(sCommandParams, Len(sCommandParams) - (iIns + 1)))
    End If
    sLft = TranslateVARS(sLft)
    sRgt = TranslateVARS(sRgt)
End If
If sCommandName = "UCASE" Then
    vntVars(iVarsNum) = UCase$(sLft)
End If
If sCommandName = "LCASE" Then
    vntVars(iVarsNum) = LCase$(sLft)
End If
If sCommandName = "RETURN" Then
    iCurCommand = iReturnStack(iStackValue)
    iStackValue = iStackValue - 1
    ReDim Preserve iReturnStack(iStackValue)
End If
If sCommandName = "RUN" Then
    If sRgt = "" Then sRgt = "Normal"
    iupload = 1
    sRgt = UCase$(sRgt)
    Select Case sRgt
        Case "NORMAL"
            iupload = 1
        Case "MINIMISED"
            iupload = 2
        Case "MAXIMISED"
            iupload = 3
    End Select
    X = Shell(sLft, iupload)
End If
If sCommandName = "DIALOG" Then
    If sRgt = "" Then sRgt = "WinBatch"
    X = MsgBox(sLft, vbOKOnly + vbInformation, sRgt)
End If
If sCommandName = "GET" Then
    If sRgt = "" Then sRgt = "WinBatch"
    vntVars(iVarsNum) = InputBox(sLft, sRgt)
End If
If sCommandName = "QUESTION" Then
    If sRgt = "" Then sRgt = "WinBatch"
    iTemp = MsgBox(sLft, vbYesNo + vbQuestion, sRgt)
    If iTemp = vbYes Then
        vntVars(iVarsNum) = "YES"
    Else
        vntVars(iVarsNum) = "NO"
    End If
End If
If sCommandName = "IF" Then
    Call IFProcess(sCommandParams)
End If
If sCommandName = "EXIT" Then
    bFinish = True
End If
If sCommandName = "GOTO" Then
    Call GOTOCommand(sLft)
End If
If sCommandName = "GOSUB" Then
    Call GOSUBCommand(sLft)
End If
If sCommandName = "PAUSE" Then
    Call Pause(sLft)
End If
Activate = True
Exit Function
noExec:
Activate = False
End Function
Sub GOTOCommand(sLabelname)
Dim sSndlne As String, iLoopvar As Integer
If iNumLabels = 0 Then Exit Sub
sSndlne = 0
For iLoopvar = 1 To iNumLabels
    If UCase$(Trim$(sLabelsArray(1, iLoopvar))) = UCase$(Trim$(sLabelname)) Then
        sSndlne = sLabelsArray(2, iLoopvar)
        Exit For
    End If
Next
If sSndlne = 0 Then Exit Sub
iCurCommand = sSndlne
End Sub

Sub GOSUBCommand(sLabelname)
Dim iSndlne As Integer, iLoopvar As Integer
If iNumLabels = 0 Then Exit Sub
iSndlne = 0
For iLoopvar = 1 To iNumLabels
    If UCase$(Trim$(sLabelsArray(1, iLoopvar))) = UCase$(Trim$(sLabelname)) Then
        iSndlne = sLabelsArray(2, iLoopvar)
        Exit For
    End If
Next
If iSndlne = 0 Then Exit Sub
iStackValue = iStackValue + 1
ReDim Preserve iReturnStack(iStackValue)
iReturnStack(iStackValue) = iCurCommand
iCurCommand = iSndlne
End Sub

Sub IFProcess(ifcommand)
Dim l1 As String, l2 As String, inm As Long, sval As Integer, is1 As Long, is2 As Long, is3 As Long, is4 As Long
Dim numcrun As Single, lft As String, rgt As String, ins As Integer
Dim istrue As Boolean, X As Boolean
inm = 0
sval = 0
is1 = InStr(ifcommand, "=")
is2 = InStr(ifcommand, ">")
is3 = InStr(ifcommand, "<")
is4 = InStr(ifcommand, "!")
If is1 = 0 Then is1 = 99999
If is2 = 0 Then is2 = 99999
If is3 = 0 Then is3 = 99999
If is4 = 0 Then is4 = 99999
numcrun = 999999
If is1 < numcrun Then
    numcrun = is1
    inm = is1
    sval = 1
End If
If is2 < numcrun Then
    numcrun = is2
    inm = is2
    sval = 2
End If
If is3 < numcrun Then
    numcrun = is3
    inm = is3
    sval = 3
End If
If is4 < numcrun Then
    numcrun = is4
    inm = is4
    sval = 4
End If

If inm = 99999 Then inm = 0
If inm > 0 Then
    lft = Trim$(Left$(ifcommand, (inm - 1)))
    rgt = Trim$(Right$(ifcommand, Len(ifcommand) - inm))
End If
lft = TranslateVARS(lft)
ins = InStr(UCase$(rgt), "THEN")
If ins > 0 Then
    l1 = Trim$(Left$(rgt, ins - 1))
    l2 = Trim$(Right$(rgt, Len(rgt) - ins - 3))
    istrue = False
    If IsNumeric(lft) Then lft = Val(lft)
    If IsNumeric(l1) Then l1 = Val(l1)
    If IsNumeric(lft) And Not IsNumeric(l1) Then
        lft = Str$(lft)
    End If
    If IsNumeric(l1) And Not IsNumeric(lft) Then
        l1 = Str$(l1)
    End If
    Select Case sval
        Case 1
            If lft = l1 Then istrue = True
        Case 2
            If lft > l1 Then istrue = True
        Case 3
            If lft < l1 Then istrue = True
        Case 4
            If lft <> l1 Then istrue = True
    End Select
    If Not istrue Then Exit Sub
    X = Parse(l2)
End If
End Sub

Sub Main()
Dim sInputString As String, bParseReturn As Boolean, iLoopvar As Integer, sfilename As String
Dim iff As Integer, slabnam As String, it As Integer

ReDim Preserve iReturnStack(1)
ReDim Preserve sCommandArray(1)
ReDim Preserve sLabelsArray(2, 1)

iStackValue = 0
bFinish = False
For iLoopvar = 1 To 12
    vntVars(iLoopvar) = ""
Next
Call GetWinDir
Call GetSysDir
vntVars(11) = sWinDir
vntVars(12) = sSysDir
On Error Resume Next
If Command$ = "" Then
    frmDummy.Show
    Exit Sub
End If
sfilename = Command$
If Dir$(sfilename) = "" Then
    sfilename = sfilename & ".wbt"
    If Dir$(sfilename) = "" Then End
End If
On Error GoTo 0
iff = FreeFile
iNumCommands = 0
iNumLabels = 0
Open sfilename For Input As #iff
While (Not EOF(iff))
    sInputString = ReadLn(iff)
    sInputString = Trim$(sInputString)
    If sInputString <> "" And Left$(sInputString, 1) <> "#" Then
        iNumCommands = iNumCommands + 1
        If iNumCommands > UBound(sCommandArray) Then ReDim Preserve sCommandArray(iNumCommands)
        sCommandArray(iNumCommands) = sInputString
        If Left$(sInputString, 1) = ":" Then
            iNumLabels = iNumLabels + 1
            If iNumLabels > UBound(sLabelsArray, 2) Then ReDim Preserve sLabelsArray(2, iNumLabels)
            slabnam = Right$(sInputString, Len(sInputString) - 1)
            sLabelsArray(1, iNumLabels) = slabnam
            sLabelsArray(2, iNumLabels) = iNumCommands
        End If
    End If
Wend
Close iff
If iNumCommands = 0 Then End
iCurCommand = 1
While iCurCommand <= iNumCommands And Not bFinish
    sInputString = sCommandArray(iCurCommand)
    iCurCommand = iCurCommand + 1
    bParseReturn = Parse(sInputString)
    If Not bParseReturn Then
        MsgBox "Error parsing : " & sInputString, vbOKOnly + vbInformation, "Incorrect command"
    End If
Wend
End Sub
Function Extract(iStr) As String
Dim p As Integer, X As String, l As Integer, dumstr As String
Dim loopvar As Integer
l = Len(iStr)
If l = 0 Then Exit Function
dumstr = ""
For loopvar = 1 To l
    If Asc(Mid$(iStr, loopvar, 1)) <> 0 Then dumstr = dumstr + Mid$(iStr, loopvar, 1)
Next
Extract = dumstr
End Function

Function Parse(sCommandString As String) As Boolean
Dim sTempString As String, sEndCommand As String, sResCommand As String
Dim iVnum As Integer, bExitnow As Boolean, iNsc As Integer
Dim bUsevar As Boolean, sL1 As String, sL2 As String, iLn As Integer, iCp As Integer
Dim sCh As String, bOkay As Boolean, bParseReturn As Boolean, iLoopvar1 As Integer, sEndingstring As String
Dim sCurrentString As String, iLoopvar2 As Integer, sCurrentOperator As String
Dim sOperString As String, sRgt As String, sLft As String

If Left$(sCommandString, 1) = ":" Then
    Parse = True
    Exit Function
End If
sTempString = sCommandString
bExitnow = False
iNsc = InStr(sCommandString, "=")
bUsevar = False
iVnum = 0
If iNsc > 0 And UCase$(Left$(sCommandString, 2)) <> "IF" Then
    sL1 = UCase$(Trim$(Left$(sCommandString, iNsc - 1)))
    sL2 = UCase$(Trim$(Right$(sCommandString, Len(sCommandString) - iNsc)))
    If Left$(sL1, 3) = "VAR" Then
        iVnum = Val(Right$(sL1, Len(sL1) - 3))
        If iVnum > 12 Then
            Parse = False
            Exit Function
        End If
        'vars(vnum) = ""
        bUsevar = True
        sTempString = sL2
    ElseIf sL1 = "WINDIR" Then
        iVnum = 11
        bUsevar = True
        sTempString = sL2
    ElseIf sL1 = "SYSDIR" Then
        iVnum = 12
        bUsevar = True
        sTempString = sL2
    Else
        Parse = False
        Exit Function
    End If
End If
iLn = Len(sTempString)
iCp = 1
sCh = Mid$(sTempString, iCp, 1)
While (iCp <= iLn) And (Not bExitnow)
    If sCh = "(" Or sCh = " " Or sCh = ":" Or sCh = "!" Or sCh = "," Or sCh = "=" Then
        bExitnow = True
    End If
    If Not bExitnow Then
        iCp = iCp + 1
        sCh = Mid$(sTempString, iCp, 1)
    End If
Wend
sEndCommand = Trim$(UCase$(Left$(sTempString, (iCp - 1))))
sResCommand = Trim$(Right$(sTempString, Len(sTempString) - (iCp - 1)))
bOkay = False
Select Case sEndCommand
    Case "RUN"
        bOkay = True
    Case "DIALOG"
        bOkay = True
    Case "GET"
        If Not bUsevar Then
            bOkay = False
        Else
            bOkay = True
        End If
    Case "QUESTION"
        If Not bUsevar Then
            bOkay = False
        Else
            bOkay = True
        End If
    Case "IF"
        bOkay = True
    Case "EXIT"
        bOkay = True
    Case "GOTO"
        bOkay = True
    Case "GOSUB"
        bOkay = True
    Case "PAUSE"
        bOkay = True
    Case "UCASE"
        If Not bUsevar Then
            bOkay = False
        Else
            bOkay = True
        End If
    Case "LCASE"
        If Not bUsevar Then
            bOkay = False
        Else
            bOkay = True
        End If
    Case "RETURN"
        bOkay = True
End Select
Parse = bOkay
If bOkay Then
    bParseReturn = Activate(sEndCommand, sResCommand, iVnum)
    If Not bParseReturn Then
        If sCommandParams <> "" Then
            sLft = sResCommand
            sRgt = ""
            iIns = InStr(sResCommand, ",") - 1
            If iIns > 0 Then
                sLft = Trim$(Left$(sResCommand, iIns))
                sRgt = Trim$(Right$(sResCommand, Len(sResCommand) - (iIns + 1)))
            End If
            sLft = TranslateVARS(sLft)
            sRgt = TranslateVARS(sRgt)
        End If
        
        sTempString = sEndCommand & " " & sLft & IIf(InStr(sResCommand, ",") > 0, ",", "") & sRgt
        
        MsgBox "Error executing : " & sTempString, vbOKOnly + vbInformation, "Unable to execute"
    End If
End If
If Not bOkay And bUsevar Then
    sOperString = "+-/*&"
    sEndingstring = ""
    sCurrentString = sL2
    For iLoopvar1 = 1 To Len(sOperString)
        sCurrentOperator = Mid$(sOperString, iLoopvar1, 1)
        If InStr(sCurrentString, sCurrentOperator) > 0 Then
            sEndingstring = sEndingstring & TranslateVARS(Trim$(Left$(sL2, InStr(sCurrentString, sCurrentOperator) - 1)))
            Select Case sCurrentOperator
                Case "+"
                    sEndingstring = sEndingstring + TranslateVARS(Trim$(Right$(sL2, Len(sL2) - InStr(sCurrentString, sCurrentOperator))))
                Case "-"
                    sEndingstring = sEndingstring - TranslateVARS(Trim$(Right$(sL2, Len(sL2) - InStr(sCurrentString, sCurrentOperator))))
                Case "*"
                    sEndingstring = sEndingstring * TranslateVARS(Trim$(Right$(sL2, Len(sL2) - InStr(sCurrentString, sCurrentOperator))))
                Case "/"
                    sEndingstring = sEndingstring / TranslateVARS(Trim$(Right$(sL2, Len(sL2) - InStr(sCurrentString, sCurrentOperator))))
                Case "&"
                    sEndingstring = sEndingstring & TranslateVARS(Trim$(Right$(sL2, Len(sL2) - InStr(sCurrentString, sCurrentOperator))))
            End Select
        End If
    Next
    If sEndingstring = "" Then sEndingstring = sL2
    sL2 = sEndingstring
    vntVars(iVnum) = sL2
    Parse = True
End If
End Function

Function ReadLn(Fnum) As String

Line Input #Fnum, ReadLn

End Function
Function TranslateVARS(sVarstring)
Dim iVnum As Integer
If UCase$(Left$(sVarstring, 3)) = "VAR" Then
    iVnum = Val(Right$(sVarstring, Len(sVarstring) - 3))
    If iVnum > 12 Or iVnum < 1 Then
        TranslateVARS = sVarstring
    Else
        TranslateVARS = vntVars(iVnum)
    End If
ElseIf UCase$(sVarstring) = "WINDIR" Then
    TranslateVARS = sWinDir
ElseIf UCase$(sVarstring) = "SYSDIR" Then
    TranslateVARS = sSysDir
Else
    TranslateVARS = sVarstring
End If
End Function


